# Before `make install' is performed this script should be runnable with
# `make test'. After `make install' it should work as `perl test.pl'

######################### We start with some black magic to print on failure.

# Change 1..1 below to 1..last_test_to_print .
# (It may become useful if the test is moved to ./t subdirectory.)

BEGIN { $| = 1; print "1..1\n"; }
END {print "not ok 1\n" unless $loaded;}
use GGI;
use GGI::Color;
$loaded = 1;
print "ok 1\n";

######################### End of black magic.

# Insert your test code below (better if it prints "ok 13"
# (correspondingly "not ok 13") depending on the success of chunk 13
# of the test code):

print "2..";
$col = new GGI::Color;
print "2\n";
print "not " unless (ref($col) and UNIVERSAL::isa($col, 'GGI::Color'));
print "OK 2\n";

print "3..3\n";
print "not " unless $col->size == 1;
print "OK 3\n";

print "4..";
$col = new GGI::Color 255;
print "4\n";
print "not " unless $col->size == 255;
print "OK 4\n";

print "5..";
$col->size(256);
print "5\n";
print "not " unless $col->size == 256;
print "OK 5\n";

print "6..";
$fail = 0;
$col->set('rgba', [ 0 .. 1023 ]);
@r = $col->get('r');
@ga = $col->get('ga');
$fail = 1 unless (@r + 0) == 256;
$fail = 1 unless (@ga + 0) == 512;
for ($i = 0; $i < $col->size; $i++) {
    $fail = 1 if $r[$i] != $i * 4;
}
for ($i = 0; $i < $col->size * 2; $i++) {
    $fail = 1 if $ga[$i] != $i * 2 + 1;
}
print "6\n";
print "not " if $fail;
print "OK 6\n";

# Tests 7 thru 9 reserved for bounds checking
print "7..";
print "7\n";
print "not " if $fail;
print "OK 7\n";

print "8..";
print "8\n";
print "not " if $fail;
print "OK 8\n";

print "9..";
print "9\n";
print "not " if $fail;
print "OK 9\n";

#print "10..";
#$vis = new GGI;
#$vis->palette();
#$col->set(r => [0 .. 256]);
#$col->set(gba => \((0) x 256 x 3);


